unit Randodec;                         //259

interface

USES
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs, Rando;

Type
  t_lig      = Record
                 Nature : string[15];
                 Vitesse: Longint;
               END;
  t_car      = ARRAY[1..3] of t_lig;
  t_caract   = ARRAY[1..5] of t_car;
  t_f_caract = file of t_caract;
  t_lig_don = RECORD
                DonTitre    : STRING[15];
                DonSouTitre : STRING[40];
                DonDate     : TDateTime;
                DonDebut    : TDateTime;
                DonFin      : TDateTime;
              END;
  t_donnees = ARRAY[0..49] OF t_lig_don;
  t_f_don   = FILE OF t_donnees;
  t_lig_iti     = RECORD
                    ItiLieu   : string[40];
                    ItiMoyen  : string[2];
                    ItiOrient : Integer;
                    ItiPos    : string[20]; //N49.46285_E002.11159
                    ItiAlt    : Integer;    //31_U_0435624_5479290
                    ItiDist   : Longint;
                    ItiTemp   : TDateTime;
                    ItiHeure  : TDateTime;
                  END;
  t_itineraire  = ARRAY[1..50] OF t_lig_iti;
  t_f_itineraire= FILE OF t_itineraire;

VAR
  caract             : T_caract;
  donnees            : t_donnees;
  itiner             : t_itineraire;
  nom_rep,ini_projet : String;
  ini_iti            : Integer;
  page               : byteBool;

PROCEDURE lecture_caracteristique;
PROCEDURE ecriture_caracteristique;
PROCEDURE lecture_donnees;
PROCEDURE ecriture_donnees;
PROCEDURE lecture_itineraire(num : Longint);
PROCEDURE ecriture_itineraire(num: Longint);
FUNCTION extraire (st : string):string;


implementation

PROCEDURE lecture_caracteristique;
VAR
  f_caract : t_f_caract;
BEGIN
  AssignFile(f_caract,nom_rep+'Randc.rnd');
  try
    Reset(f_caract);
  EXCEPT
    ON EInOutError DO
    BEGIN
      caract[1,1].Nature := 'Autoroute';caract[1,1].Vitesse := 100;
      caract[1,2].Nature := 'Nationnale';caract[1,2].Vitesse := 70;
      caract[1,3].Nature := 'Dpartementale';caract[1,3].Vitesse := 50;
      caract[2,1].Nature := 'Nationnale';caract[2,1].Vitesse := 70;
      caract[2,2].Nature := 'Dpartementale';caract[2,2].Vitesse := 50;
      caract[2,3].Nature := 'Forestire';caract[2,3].Vitesse := 30;
      caract[3,1].Nature := 'Mont';caract[3,1].Vitesse := 15;
      caract[3,2].Nature := 'Plat';caract[3,2].Vitesse := 20;
      caract[3,3].Nature := 'Descente';caract[3,3].Vitesse := 25;
      caract[4,1].Nature := 'Mont';caract[4,1].Vitesse := 300;
      caract[4,2].Nature := 'Plat';caract[4,2].Vitesse := 4000;
      caract[4,3].Nature := 'Descente';caract[4,3].Vitesse := 500;
      caract[5,1].Nature := 'Arrt';caract[5,1].Vitesse := 15;
      caract[5,2].Nature := 'Collation';caract[5,2].Vitesse := 30;
      caract[5,3].Nature := 'Repas';caract[5,3].Vitesse := 60;
      Rewrite(f_caract);WRITE(f_caract,caract);CloseFile(F_caract);
    END;
  END;
  Reset(f_caract);Read(f_caract,caract);CloseFile(F_caract);
END;

PROCEDURE lecture_itineraire(num : Longint);
VAR
  f_itineraire : t_f_itineraire;
  i            : BYTE;
BEGIN
  AssignFile(f_itineraire,
             nom_rep+ini_projet+'\'+'rand'+IntToStr(num)+'.rnd');
  TRY
    Reset(f_itineraire);
  EXCEPT
    ON EInOutError DO
    BEGIN
      FOR i:=1 TO 50 DO
        WITH itiner[i] DO
        BEGIN
          ItiLieu := '';ItiMoyen := '';ItiOrient := 0;ItiPos := '';
          ItiAlt := 0;ItiDist :=0;ItiTemp := 0;ItiHeure := 0;
        END;
      Rewrite(f_itineraire);WRITE(f_itineraire,itiner);CloseFile(f_itineraire);
    END;
  END;
  Reset(f_itineraire);Read(f_itineraire,itiner);CloseFile(f_itineraire);
  WITH Rand DO
  BEGIN
    liste_eta.Cells[0,0] := 'LIEU';
    liste_eta.Cells[1,0] := 'Moyen';
    liste_eta.Cells[2,0] := 'Orientation';
    liste_eta.Cells[3,0] := 'Position';
    liste_eta.Cells[4,0] := 'Altitude';
    liste_eta.Cells[5,0] := 'Distance';
    liste_eta.Cells[6,0] := 'Heure';
    FOR i:= 1 TO 50 DO
      WITH itiner[i] DO
      BEGIN
        liste_eta.Cells[0,i] := ItiLieu;
        liste_eta.Cells[1,i] := ItiMoyen;
        IF ItiOrient<>0
        THEN liste_eta.Cells[2,i] := IntToStr(ItiOrient)
        ELSE liste_eta.Cells[2,i] := '';
        liste_eta.Cells[3,i] := ItiPos;
        IF ItiAlt<>0
        THEN liste_eta.Cells[4,i] := IntToStr(ItiAlt)
        ELSE liste_eta.Cells[4,i] := '';
        IF ItiDist<>0
        THEN liste_eta.Cells[5,i] := IntToStr(ItiDist)
        ELSE liste_eta.Cells[5,i] := '';
        IF ItiHeure<>0
        THEN liste_eta.Cells[6,i] := Copy(TimeToStr(ItiHeure),1,5)
        ELSE liste_eta.Cells[6,i] := '';
      END;
  END;
END;

PROCEDURE ecriture_itineraire(num: Longint);
VAR
  f_itineraire : t_f_itineraire;
  i            : Byte;
BEGIN
  FOR i := 1 TO 50 DO
    WITH itiner[i] DO
      WITH Rand DO
      BEGIN
        ItiLieu := liste_eta.Cells[0,i];
        ItiMoyen := liste_eta.Cells[1,i];
        IF liste_eta.Cells[2,i]<>''
        THEN ItiOrient := StrToInt(liste_eta.Cells[2,i])
        ELSE ItiOrient := 0;
        ItiPos := liste_eta.Cells[3,i];
        IF liste_eta.Cells[4,i]<>''
        THEN ItiAlt := StrToInt(liste_eta.Cells[4,i])
        ELSE ItiAlt := 0;
        IF liste_eta.Cells[5,i]<>''
        THEN ItiDist := StrToInt(liste_eta.Cells[5,i])
        ELSE ItiDist := 0;
        IF liste_eta.Cells[6,i]<>''
        THEN ItiHeure := StrToTime(liste_eta.Cells[6,i])
        ELSE ItiHeure := 0;
      END;
  AssignFile(f_itineraire,
             nom_rep+ini_projet+'\'+'rand'+IntToStr(num)+'.rnd');
  Rewrite(f_itineraire);WRITE(f_itineraire,itiner);CloseFile(f_itineraire);
END;

PROCEDURE ecriture_caracteristique;
VAR
  f_caract : t_f_caract;
BEGIN
  AssignFile(f_caract,nom_rep+'Randc.rnd');
  Reset(f_caract);Write(f_caract,caract);CloseFile(F_caract);
END;

PROCEDURE lecture_donnees;
VAR
  f_donnees : t_f_don;
  i         : BYTE;
  fichier   : String;
BEGIN
  fichier := nom_rep+ini_projet+'\'+'Randd.rnd';
  AssignFile(f_donnees,fichier);
  TRY
    Reset(f_donnees);
  EXCEPT
    ON EInOutError DO
    BEGIN
      FOR i:=0 TO 49 DO
        WITH donnees[i] DO
        BEGIN
          DonTitre := '';DonSouTitre := '';DonDate := 0;DonDebut := 0;DonFin :=0;
        END;
      Rewrite(f_donnees);WRITE(f_donnees,donnees);CloseFile(F_donnees);
    END;
  END;
  Reset(f_donnees);Read(f_donnees,donnees);CloseFile(f_donnees);
  FOR i := 0 TO 49 DO
  BEGIN
    WITH Rand DO
    BEGIN
      Liste_iti.Cells[0,i] := donnees[i].DonTitre;
      Liste_iti.Cells[1,i] := donnees[i].DonSouTitre;
      IF (donnees[i].DonDate<>0)
      THEN Liste_iti.Cells[2,i] := DateToStr(donnees[i].DonDate)
      ELSE Liste_iti.Cells[2,i] := '';
      IF (donnees[i].DonDebut<>0)
      THEN Liste_iti.Cells[3,i] := Copy(TimeToStr(donnees[i].DonDebut),1,5)
      ELSE Liste_iti.Cells[3,i] := '';
      IF (donnees[i].DonFin<>0)
      THEN Liste_iti.Cells[4,i] := Copy(TimeToStr(donnees[i].DonFin),1,5)
      ELSE Liste_iti.Cells[4,i] := '';
    END;
  END;
END;

PROCEDURE ecriture_donnees;
VAR
  f_donnees : t_f_don;
  fichier   : String;
  i         : Byte;
BEGIN
  FOR i := 0 TO 49 DO
  BEGIN
    WITH Rand DO
    BEGIN
      donnees[i].DonTitre := UpperCase(Liste_iti.Cells[0,i]);
      donnees[i].DonSouTitre := Liste_iti.Cells[1,i];
      IF Liste_iti.Cells[2,i]<>''
      THEN donnees[i].DonDate := StrToDate(Liste_iti.Cells[2,i])
      ELSE donnees[i].DonDate := 0;
      IF Liste_iti.Cells[3,i]<>''
      THEN donnees[i].DonDebut := StrToTime(Liste_iti.Cells[3,i])
      ELSE donnees[i].DonDebut := 0;
      IF Liste_iti.Cells[4,i]<>''
      THEN donnees[i].DonFin := StrToTime(Liste_iti.Cells[4,i])
      ELSE donnees[i].DonFin := 0;
    END;
  END;
  fichier := nom_rep+ini_projet+'\'+'Randd.rnd';
  AssignFile(f_donnees,fichier);Reset(f_donnees);WRITE(f_donnees,donnees);CloseFile(f_donnees);
END;

FUNCTION extraire (st : string):string;
VAR
  i,j  : BYTE;
BEGIN
  j := 0;
  FOR i := 1 TO length(nom_rep) DO
  IF Upcase(st[i])=Upcase(nom_rep[i])
  THEN INC(j)
  ELSE BREAK;
  Delete(st,1,j);extraire := st;
END;

end.
