unit Randopla;                         //882

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, Mask;

type
  TRandpla = class(TForm)
    ScrollBox1: TScrollBox;
    Calibra: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    M_Zone: TMaskEdit;
    UpZone: TUpDown;
    M_lettre: TMaskEdit;
    UpLettre: TUpDown;
    Label5: TLabel;
    Label6: TLabel;
    X1_c: TMaskEdit;
    CheckP1: TCheckBox;
    X1_i: TLabel;
    Y1_c: TMaskEdit;
    Y1_i: TLabel;
    CheckP2: TCheckBox;
    X2_c: TMaskEdit;
    Label7: TLabel;
    X2_i: TLabel;
    Y2_i: TLabel;
    Label10: TLabel;
    Y2_c: TMaskEdit;
    Label8: TLabel;
    M_Systeme: TMaskEdit;
    UpSystem: TUpDown;
    CheckP3: TCheckBox;
    Label9: TLabel;
    X3_c: TMaskEdit;
    X3_i: TLabel;
    Y3_i: TLabel;
    Label13: TLabel;
    Y3_c: TMaskEdit;
    ValiCalibr: TButton;
    VerifCalibra: TPanel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label24: TLabel;
    LZone: TLabel;
    LLettre: TLabel;
    LSysteme: TLabel;
    LX: TLabel;
    LY: TLabel;
    Label11: TLabel;
    C_Bonne: TButton;
    C_Fauuse: TButton;
    Label12: TLabel;
    Waypoints: TPanel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    WZone: TLabel;
    WLettre: TLabel;
    WSysteme: TLabel;
    WX: TLabel;
    WY: TLabel;
    Wnouveau: TButton;
    WImprimer: TButton;
    Wsupprimer: TButton;
    Routes: TPanel;
    RNouvelle: TButton;
    RSupprimer: TButton;
    Label23: TLabel;
    RWaypoints: TButton;
    ChRoutes: TListBox;
    RLWaypoints: TEdit;
    RLNouvelle: TEdit;
    RLsupprimer: TEdit;
    LEchelle: TLabel;
    Label26: TLabel;
    WPoints: TListBox;
    Label25: TLabel;
    Label27: TLabel;
    WCarte: TLabel;
    Label28: TLabel;
    WZ: TEdit;
    OpenDialog1: TOpenDialog;
    WHaut: TButton;
    WDroit: TButton;
    WGauche: TButton;
    WBas: TButton;
    WDessiner: TButton;
    Label29: TLabel;
    Label30: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    PrintDialog1: TPrintDialog;
    procedure FormActivate(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1Click(Sender: TObject);
    procedure CheckP1Click(Sender: TObject);
    procedure CheckP2Click(Sender: TObject);
    procedure UpZoneClick(Sender: TObject; Button: TUDBtnType);
    procedure UpLettreClick(Sender: TObject; Button: TUDBtnType);
    procedure CheckP3Click(Sender: TObject);
    procedure ValiCalibrClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure C_FauuseClick(Sender: TObject);
    procedure UpSystemClick(Sender: TObject; Button: TUDBtnType);
    procedure ChRoutesClick(Sender: TObject);
    procedure RNouvelleClick(Sender: TObject);
    procedure RSupprimerClick(Sender: TObject);
    procedure RWaypointsClick(Sender: TObject);
    procedure C_BonneClick(Sender: TObject);
    procedure WPointsClick(Sender: TObject);
    procedure WZChange(Sender: TObject);
    procedure WsupprimerClick(Sender: TObject);
    procedure WnouveauClick(Sender: TObject);
    procedure WDessinerClick(Sender: TObject);
    procedure WHautClick(Sender: TObject);
    procedure WBasClick(Sender: TObject);
    procedure WGaucheClick(Sender: TObject);
    procedure WDroitClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure WImprimerClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;
   

var
  Randpla: TRandpla;

implementation

{$R *.DFM}

USES
  JPEG,Rando,Randodec,Printers;
  
TYPE
  t_matrice = ARRAY[1..3,0..3] OF Int64;
  t_coef    = ARRAY[1..3] OF REAL;

VAR
  Coef_Xi,Coef_Yi : t_coef;
  Coef_Xc,Coef_Yc : t_coef;
  calibration     : TStringList;
  L_routes        : TStringList;
  L_Points        : TStringList;
  futur_point     : String;
  ImageBMP        : TBitmap;
  densX,densY     : Word;


FUNCTION Resol_matrice(matr:t_matrice):t_coef;
VAR
  mat          : t_matrice;
  R_Coef       : t_Coef;
  i,j          : BYTE;
  FUNCTION determinant(ma:t_matrice): Int64;
  BEGIN
    determinant := (ma[1,1]*((ma[2,2]*ma[3,3])-(ma[3,2]*ma[2,3])))-
                   (ma[2,1]*((ma[1,2]*ma[3,3])-(ma[3,2]*ma[1,3])))+
                   (ma[3,1]*((ma[1,2]*ma[2,3])-(ma[2,2]*ma[1,3])));
  END;
BEGIN
  mat := matr;
  IF determinant(mat)=0
  THEN BEGIN
    FOR i:=1 TO 3 DO
      R_Coef[i] := 0.0;
    Resol_Matrice := R_Coef;Exit;
  END;
  FOR i:=1 TO 3 DO
  BEGIN
    matr := mat;
    FOR j:=1 TO 3 DO
      matr[j,i] := matr[j,0];
    R_Coef[i] := determinant(matr)/determinant(mat);
  END;
  Resol_Matrice := R_Coef;
END;

FUNCTION calcul_coef:BOOLEAN;
VAR
  ma          : t_Matrice;
  c_b         : BOOLEAN;
  FileJpg     : FILE OF BYTE;
  UnitJpg,j   : Byte;
  ValDensit   : Real;
  balise      : string;
BEGIN
  WITH RandPLa DO
  BEGIN
    ma[1,0] := StrToInt(X1_c.text);ma[1,1] := 1;
    ma[1,2] := StrToInt(X1_i.Caption);ma[1,3] := StrToInt(Y1_i.Caption);
    ma[2,0] := StrToInt(X2_c.text);ma[2,1] := 1;
    ma[2,2] := StrToInt(X2_i.Caption);ma[2,3] := StrToInt(Y2_i.Caption);
    ma[3,0] := StrToInt(X3_c.text);ma[3,1] := 1;
    ma[3,2] := StrToInt(X3_i.Caption);ma[3,3] := StrToInt(Y3_i.Caption);
    Coef_Xc := resol_Matrice(ma);
    ma[1,0] := StrToInt(Y1_c.text);ma[1,1] := 1;
    ma[1,2] := StrToInt(X1_i.Caption);ma[1,3] := StrToInt(Y1_i.Caption);
    ma[2,0] := StrToInt(Y2_c.text);ma[2,1] := 1;
    ma[2,2] := StrToInt(X2_i.Caption);ma[2,3] := StrToInt(Y2_i.Caption);
    ma[3,0] := StrToInt(Y3_c.text);ma[3,1] := 1;
    ma[3,2] := StrToInt(X3_i.Caption);ma[3,3] := StrToInt(Y3_i.Caption);
    Coef_Yc:= resol_Matrice(ma);
    c_b := (Coef_Xc[1]<>0.0) AND (Coef_Yc[1]<>0.0);
    IF C_b
    THEN BEGIN
      ma[1,0] := StrToInt(X1_i.Caption);ma[1,1] := 1;
      ma[1,2] := StrToInt(X1_c.Text);ma[1,3] := StrToInt(Y1_c.Text);
      ma[2,0] := StrToInt(X2_i.Caption);ma[2,1] := 1;
      ma[2,2] := StrToInt(X2_c.Text);ma[2,3] := StrToInt(Y2_c.Text);
      ma[3,0] := StrToInt(X3_i.Caption);ma[3,1] := 1;
      ma[3,2] := StrToInt(X3_c.Text);ma[3,3] := StrToInt(Y3_c.Text);
      Coef_Xi := resol_Matrice(ma);
      ma[1,0] := StrToInt(Y1_i.Caption);ma[1,1] := 1;
      ma[1,2] := StrToInt(X1_c.Text);ma[1,3] := StrToInt(Y1_c.Text);
      ma[2,0] := StrToInt(Y2_i.Caption);ma[2,1] := 1;
      ma[2,2] := StrToInt(X2_c.Text);ma[2,3] := StrToInt(Y2_c.Text);
      ma[3,0] := StrToInt(Y3_i.Caption);ma[3,1] := 1;
      ma[3,2] := StrToInt(X3_c.Text);ma[3,3] := StrToInt(Y3_c.Text);
      Coef_Yi:= resol_Matrice(ma);
      AssignFile(FileJpg,Randpla.Caption);Reset(FileJpg);balise := '';
      WHILE balise<>'JFIF' DO
      BEGIN
        Read(FileJpg,j);
        IF Chr(j) IN ['J','F','I']
        THEN balise := balise + Chr(j)
        ELSE balise := '';
      END;
      Read(FileJpg,j);// chaine  zro terminal FFIF
      Read(FileJpg,j);Read(FileJpg,j);// Version du fichier01 00 -> 1.0
      Read(FileJpg,UnitJpg);     // Unit de la densit
      IF UnitJpg=1
      THEN ValDensit := 0.0254   // par pouce
      ELSE ValDensit := 0.010;   // par centimtre
      Read(FileJpg,j);densX := j*256;     // densit des X
      Read(FileJpg,j);Inc(densX,j);       // densit des X
      Read(FileJpg,j);densY := j*256;     // densit des Y
      Read(FileJpg,j);Inc(densY,j);       // densit des Y
      CloseFile(FileJpg);
      Randpla.LEchelle.Caption :=IntToStr(Round(
                               ((Abs(Coef_Xc[2])/(ValDensit/densX))+
                                (Abs(Coef_Yc[3])/(ValDensit/densY)))/2));
    END;
    calcul_coef := c_b;
  END;
END;

FUNCTION lit_Calibr:BOOLEAN;
VAR
  lb     : BOOLEAN;
BEGIN
  lb := TRUE;
  TRY
    Calibration.LoadFromFile(Copy(Randpla.Caption,1,
                             Length(Randpla.Caption)-4)+'.Cal');
  EXCEPT
    ON EFOpenError DO
    BEGIN
      lb :=FALSE;
    END;
  END;
  IF lb
  THEN
  WITH Randpla DO
  BEGIN
    LZone.Caption := Calibration[0];LLettre.Caption := Calibration[1];
    LSysteme.Caption := Calibration[2];
    WZone.Caption := Calibration[0];WLettre.Caption := Calibration[1];
    WSysteme.Caption := Calibration[2];
    X1_i.Caption := Calibration[3];X1_c.Text := Calibration[4];
    Y1_i.Caption := Calibration[5];Y1_c.Text := Calibration[6];
    X2_i.Caption := Calibration[7];X2_c.Text := Calibration[8];
    Y2_i.Caption := Calibration[9];Y2_c.Text := Calibration[10];
    X3_i.Caption := Calibration[11];X3_c.Text := Calibration[12];
    Y3_i.Caption := Calibration[13];Y3_c.Text := Calibration[14];
    calcul_coef;
  END;
  lit_Calibr := lb;
END;

PROCEDURE Renseigner;
VAR
  str   : STRING;
  i,j,k : Integer;
BEGIN
  Randpla.Image1.Picture.Assign(ImageBMP);
  str := ' '+Randpla.LZone.Caption+Randpla.LLettre.Caption+' '+
         Randpla.LSysteme.Caption+' ';
  WITH Randpla.Image1 DO
  BEGIN
    WITH Canvas.Font DO
    BEGIN
      Name := 'Arial';Size := densX DIV 10;Color := clBlue;
    END;
    Canvas.TextOut(((Width-Canvas.TextWidth(str)) DIV 2),20,str);
    k := (Round(Coef_Xc[1]+Coef_Xc[3]*40) DIV 1000);
    FOR i:=0 TO Width DO
    BEGIN
      j := Trunc(Coef_Xc[1]+Coef_Xc[2]*i+Coef_Xc[3]*40) DIV 1000;
      IF (j<>k)
      THEN BEGIN
        str := ' '+IntToStr(j*1000)+' ';
        Canvas.TextOut(i-(Canvas.TextWidth(str) DIV 2),40,str);k := j;
      END;
    END;
    k := (Round(Coef_Yc[1]+Coef_Yc[2]*40) DIV 1000);
    FOR i:=0 TO Height DO
    BEGIN
      j := Trunc(Coef_Yc[1]+Coef_Yc[2]*40+Coef_Yc[3]*i) DIV 1000;
      IF (j<>k)
      THEN BEGIN
        str := ' '+IntToStr((j+1)*1000)+' ';
        Canvas.TextOut(0,i-(Canvas.TextHeight(str) DIV 2),str);k := j;
//        Canvas.TextOut(40-(Canvas.TextWidth(str) DIV 2),
  //                     i-(Canvas.TextHeight(str) DIV 2),str);k := j;
      END;
    END;
  END;
END;

PROCEDURE tracer;
VAR
  ch_t1      : STRING;
  i,j,k      : Integer;
  r_t        : Real;
  tx1,ty1    : Integer;
  tx2,ty2    : Integer;
  grx,gry,gr : Integer;
BEGIN
  ch_t1 := Copy(Randpla.Label25.Caption,Length(Randpla.Label25.Caption)-1,2)+
           'AAA';
  FOR i:= ORD('9') DOWNTO ORD('0') DO
    FOR j:= ORD('9') DOWNTO ORD('0') DO
      FOR k:=ORD('9') DOWNTO ORD('0') DO
      BEGIN
        ch_t1[3] := Chr(i);ch_t1[4] := Chr(j);ch_t1[5] := Chr(k);
        IF L_Points.IndexOf(ch_t1)=-1
        THEN futur_point := ch_t1;
      END;
  grx := (densX DIV 50)+1;
  gry := (densY DIV 50+1);
  gr := ((densX+densY) DIV 300)+1;
  IF L_Points.Count>0
  THEN BEGIN
    tx1 := Round(Coef_Xi[1]+
                 Coef_Xi[2]*StrToInt(L_Points[1])+
                 Coef_Xi[3]*StrToInt(L_Points[2]));
    ty1 := Round(Coef_Yi[1]+
                 Coef_Yi[2]*StrToInt(L_Points[1])+
                 Coef_Yi[3]*StrToInt(L_Points[2]));
    Randpla.Image1.Canvas.Font.Color := clRed;
    Randpla.Image1.Canvas.TextOut(tx1-2*(densX DIV 10)+StrToInt(L_Points[8]),
                                  ty1-2*(densY DIV 10)+StrToInt(L_Points[9]),
                                  L_Points[0]);
    Randpla.Image1.Canvas.Pen.Color := clRed;
    Randpla.Image1.Canvas.Pen.Width := gr;
    Randpla.Image1.Canvas.Ellipse(tx1-(grx*2),ty1-(gry*2),tx1+(grx*2),ty1+(gry*2));
  END;
  i := 1;
  WHILE (l_Points.Count>(i*10)) DO
  BEGIN 
    tx2 := tx1;ty2 := ty1;
    tx1 := Round(Coef_Xi[1]+
                 Coef_Xi[2]*StrToInt(L_Points[1+(i*10)])+
                 Coef_Xi[3]*StrToInt(L_Points[2+(i*10)]));
    ty1 := Round(Coef_Yi[1]+
                 Coef_Yi[2]*StrToInt(L_Points[1+(i*10)])+
                 Coef_Yi[3]*StrToInt(L_Points[2+(i*10)]));
    Randpla.Image1.Canvas.TextOut(tx1-20+StrToInt(L_Points[8+(i*10)]),
                                  ty1-20++StrToInt(L_Points[9+(i*10)]),
                                  L_Points[0+(i*10)]);
    Randpla.Image1.Canvas.Ellipse(tx1-grx,ty1-gry,tx1+grx,ty1+gry);
    Randpla.Image1.Canvas.MoveTo(tx2,ty2);
    Randpla.Image1.Canvas.LineTo(tx1,ty1);INC(i);
  END;
END;


PROCEDURE Mettre_Points;
VAR
  i,j,k,l       : Integer;
  ch_mp         : String;
  LS_Points     : TStringList;
BEGIN
  LS_Points := TStringList.Create;LS_points.Clear;
  Ch_mp := nom_rep+ini_projet+'\'+'Randr.'+
           Copy(Randpla.Label25.Caption,Length(Randpla.Label25.Caption)-1,2);
  IF Randpla.Wpoints.Items.Count>0
  THEN BEGIN
    FOR i:= 0 TO Randpla.WPoints.Items.Count-1 DO
    BEGIN
      j := L_Points.IndexOf(Randpla.WPoints.Items[i]);
      IF j=-1
      THEN BEGIN
        LS_Points.Add(Randpla.Wpoints.Items[i]);
        LS_Points.Add(Randpla.WX.Caption);
        LS_Points.Add(Randpla.WY.Caption);
        LS_Points.Add(Randpla.wz.Text);
        LS_Points.Add(Randpla.WCarte.Caption);
        LS_Points.Add(Randpla.Wzone.Caption);
        LS_Points.Add(Randpla.WLettre.Caption);
        LS_Points.Add(Randpla.WSysteme.Caption);
        LS_Points.Add('0');
        LS_Points.Add('0');
      END;
      IF j>-1
      THEN FOR k:=0 TO 9 DO
        LS_Points.Add(L_Points[j+k]);
    END;
  END;
  L_Points.Clear; L_Points.AddStrings(LS_Points);
  L_Points.SaveToFile(ch_mp);LS_Points.Free;tracer;
  Randpla.WPoints.ItemIndex := Randpla.WPoints.Items.Count-1;
END;


PROCEDURE Lit_Points;
VAR
  i     : Integer;
  ch_lp : String;
BEGIN
  Randpla.WPoints.Items.Clear;
  ch_lp := nom_rep+ini_projet+'\'+'Randr.'+
           Copy(Randpla.Label25.Caption,Length(Randpla.Label25.Caption)-1,2);
  TRY
    L_Points.LoadFromFile(ch_lp);
  EXCEPT
    ON EFOpenError DO
    BEGIN
      L_Points.Clear;
    END;
  END;
  IF L_Points.Count>0
  THEN BEGIN
    FOR i := 0 TO (L_Points.Count DIV 10)-1 DO
      Randpla.WPoints.Items.Add(L_Points[i*10]);
  END;
  tracer;
END;

PROCEDURE Lit_Routes;
VAR
  i : Integer;
BEGIN
  Randpla.ChRoutes.Items.Clear;
  TRY
    L_Routes.LoadFromFile(nom_rep+ini_projet+'\'+'Randr.rnd');
  EXCEPT
    ON EFOpenError DO
    BEGIN
      L_Routes.Clear;
    END;
  END;
  IF L_Routes.Count>0
  THEN BEGIN
    FOR i := 0 TO (L_Routes.Count DIV 2)-1 DO
      Randpla.ChRoutes.Items.Add(L_Routes[i*2]);
  END;
END;

PROCEDURE Mettre_jour;
VAR
  i,j,k,l       : Integer;
  ch_mj1,ch_mj2 : String;
  LS_Routes     : TStringList;
BEGIN
  LS_Routes := TStringList.Create;LS_Routes.Clear;
  IF Randpla.ChRoutes.Items.Count>0
  THEN BEGIN
    FOR i:= 0 TO Randpla.ChRoutes.Items.Count-1 DO
    BEGIN
      j := L_Routes.IndexOf(Randpla.ChRoutes.Items[i]);
      IF j=-1
      THEN BEGIN
        LS_Routes.Add(Randpla.ChRoutes.Items[i]);
        FOR k:=ORD('Z') DOWNTO ORD('A') DO
          FOR l:=ORD('Z') DOWNTO ORD('A') DO
          BEGIN
            ch_mj2 := Chr(k)+Chr(l);
            IF L_Routes.IndexOf(ch_mj2)=-1
            THEN ch_mj1 := ch_mj2;
          END;
        LS_Routes.Add(ch_mj1);
      END;
      IF j>-1
      THEN BEGIN
        LS_Routes.Add(L_Routes[j]);LS_Routes.Add(L_Routes[(j)+1]);
      END;
    END;
  END;
  L_Routes.Clear; L_Routes.AddStrings(LS_Routes);
  L_Routes.SaveToFile(nom_rep+ini_projet+'\'+'Randr.rnd');
  LS_Routes.Free;
END;

PROCEDURE MiseEnRoute;
VAR
  ImageJPG : TJPEGImage;
BEGIN
  WITH Randpla DO
  BEGIN
    ImageJPG := TJPEGImage.Create;ImageJPG.LoadFromFile(Randpla.Caption);
    ImageBMP.Height := ImageJPG.Height;ImageBMP.Width := ImageJPG.Width;
    ImageBMP.Canvas.Draw(0,0,ImageJPG);
    Image1.Picture.Assign(ImageBMP); ImageJPG.Free;
    Randpla.RLNouvelle.Text := Rand.liste_iti.Cells[1,Rand.liste_iti.Row];
    UpZone.Position := 31;M_Zone.Text := IntToStr(UpZone.position);
    UpLettre.Min := Ord('C');UpLettre.Max := Ord('X');
    UpLettre.Position := Ord('U');M_Lettre.Text := Chr(UpLettre.position);
    CheckP1.Checked := TRUE;
    VerifCalibra.Visible := FALSE;calibra.Visible := FALSE;
    Waypoints.Visible := FALSE;Routes.Visible := FALSE;
    RWaypoints.Enabled := FALSE;RSupprimer.Enabled := FALSE;
    IF lit_calibr
    THEN VerifCalibra.Visible := TRUE
    ELSE calibra.Visible := TRUE;
    Lit_Routes;
  END;
END;

procedure TRandpla.FormActivate(Sender: TObject);
begin
  Calibration := TstringList.Create;L_Routes := TstringList.Create;
  L_Points :=TstringList.Create;ImageBMP := TBitmap.Create;
  MiseEnRoute;
end;

procedure TRandpla.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y      : Integer);
VAR
  rx,ry  : Real;
begin
  IF Calibra.Visible
  THEN BEGIN
    IF CheckP1.Checked
    THEN BEGIN
      X1_i.Caption := IntToStr(x);Y1_i.Caption := IntToStr(y);
    END;
    IF CheckP2.Checked
    THEN BEGIN
      X2_i.Caption := IntToStr(x);Y2_i.Caption := IntToStr(y);
    END;
    IF CheckP3.Checked
    THEN BEGIN
      X3_i.Caption := IntToStr(x);Y3_i.Caption := IntToStr(y);
    END;
  END;
   rx := Coef_Xc[1]+Coef_Xc[2]*x+Coef_Xc[3]*y;
   ry := Coef_Yc[1]+Coef_Yc[2]*x+Coef_Yc[3]*y ;
  IF VerifCalibra.Visible
  THEN BEGIN
    LX.Caption := IntToStr(Round(rx));
    LY.Caption := IntToStr(Round(ry));
  END;
  IF Waypoints.Visible
  THEN BEGIN
    WX.Caption := IntToStr(Round(rx));
    WY.Caption := IntToStr(Round(ry));
  END;
end;

procedure TRandpla.Image1Click(Sender: TObject);
begin
  IF calibra.Visible
  THEN BEGIN
    IF CheckP1.Checked
    THEN CheckP1.Checked := FALSE;
    IF CheckP2.Checked
    THEN CheckP2.Checked := FALSE;
    IF CheckP3.Checked
    THEN CheckP3.Checked := FALSE;
  END;
  IF Waypoints.Visible
  THEN BEGIN
    IF WPoints.ItemIndex=WPoints.Items.Count-1
    THEN Wpoints.Items.Add(futur_point)
    ELSE WPoints.Items.Insert(WPoints.ItemIndex+1,futur_point);
    WCarte.Caption := ExtractFileName(Randpla.Caption);
    mettre_Points;
  END;
end;

procedure TRandpla.CheckP1Click(Sender: TObject);
begin
  IF CheckP1.Checked
  THEN BEGIN
    CheckP2.Checked := FALSE;CheckP3.Checked := FALSE;
    ScrollBox1.HorzScrollBar.Position := 0;
    ScrollBox1.VertScrollBar.Position := 0;
  END;
end;

procedure TRandpla.CheckP2Click(Sender: TObject);
begin
  IF CheckP2.Checked
  THEN BEGIN
    CheckP1.Checked := FALSE;CheckP3.Checked := FALSE;
    ScrollBox1.HorzScrollBar.Position := ScrollBox1.HorzScrollBar.Range;
    ScrollBox1.VertScrollBar.Position := ScrollBox1.VertScrollBar.Range;
  END;
end;

procedure TRandpla.UpZoneClick(Sender: TObject; Button: TUDBtnType);
begin
  M_Zone.text := IntToStr(UpZone.Position);
end;

procedure TRandpla.UpLettreClick(Sender: TObject; Button: TUDBtnType);
begin
  M_Lettre.Text := Chr(UpLettre.position);
end;

procedure TRandpla.CheckP3Click(Sender: TObject);
begin
  IF CheckP3.Checked
  THEN BEGIN
    CheckP2.Checked := FALSE;CheckP1.Checked := FALSE;
    ScrollBox1.HorzScrollBar.Position := 0;
    ScrollBox1.VertScrollBar.Position := ScrollBox1.VertScrollBar.Range;
  END;
end;

procedure TRandpla.ValiCalibrClick(Sender: TObject);
begin
  If calcul_coef
  THEN BEGIN
    Calibra.Visible := FALSE;VerifCalibra.Visible := TRUE;
    WITH Randpla DO
    BEGIN
      Calibration.Clear;
      Calibration.Add(M_Zone.Text);Calibration.Add(M_Lettre.Text);
      Calibration.Add(M_Systeme.Text);
      Calibration.Add(X1_i.Caption);Calibration.Add(X1_c.Text);
      Calibration.Add(Y1_i.Caption);Calibration.Add(Y1_c.Text);
      Calibration.Add(X2_i.Caption);Calibration.Add(X2_c.Text);
      Calibration.Add(Y2_i.Caption);Calibration.Add(Y2_c.Text);
      Calibration.Add(X3_i.Caption);Calibration.Add(X3_c.Text);
      Calibration.Add(Y3_i.Caption);Calibration.Add(Y3_c.Text);
      LZone.Caption := Calibration[0];LLettre.Caption := Calibration[1];
      LSysteme.Caption := Calibration[2];
      WZone.Caption := Calibration[0];WLettre.Caption := Calibration[1];
      WSysteme.Caption := Calibration[2];
    END;
    Calibration.SaveToFile(Copy(Randpla.Caption,1,
                           Length(Randpla.Caption)-4)+'.Cal');
  END;

end;

procedure TRandpla.FormDeactivate(Sender: TObject);
begin
  Calibration.Free;L_Routes.Free;L_Points.Free;ImageBMP.FreeImage;
end;

procedure TRandpla.C_FauuseClick(Sender: TObject);
begin
  VerifCalibra.Visible := FALSE;Calibra.Visible := TRUE;
end;

procedure TRandpla.UpSystemClick(Sender: TObject; Button: TUDBtnType);
begin
  CASE UpSystem.Position OF
    1:M_Systeme.text := 'ED50';
    2:M_Systeme.text := 'WGS84';
  END;
end;

procedure TRandpla.ChRoutesClick(Sender: TObject);
begin
  RLSupprimer.Text := ChRoutes.Items.Strings[chRoutes.ItemIndex];
  RLWaypoints.Text := ChRoutes.Items.Strings[chRoutes.ItemIndex];
  RWaypoints.Enabled := TRUE;RSupprimer.Enabled := TRUE;
end;

procedure TRandpla.RNouvelleClick(Sender: TObject);
begin
  IF (Length(RLNouvelle.Text)>2)
      AND ( ChRoutes.Items.IndexOf(RLNouvelle.Text) = -1 )
  THEN BEGIN
    ChRoutes.Items.Insert(ChRoutes.ItemIndex+1,RLNouvelle.Text);
    mettre_jour;
  END;
end;

procedure TRandpla.RSupprimerClick(Sender: TObject);
begin
  ChRoutes.Items.Delete(ChRoutes.ItemIndex);mettre_jour;
end;

procedure TRandpla.RWaypointsClick(Sender: TObject);
VAR
  j : Integer;
begin
  Routes.Visible := FALSE;Waypoints.Visible := TRUE;
  j := L_Routes.IndexOf(RLWaypoints.Text);
  Label25.Caption := L_Routes[j]+' >'+L_Routes[j+1];
  Lit_Points;
end;

procedure TRandpla.C_BonneClick(Sender: TObject);
begin
  Renseigner;VerifCalibra.Visible := FALSE;Routes.Visible := TRUE;
end;

procedure TRandpla.WPointsClick(Sender: TObject);
VAR
  i : Integer;
begin
  i := L_Points.IndexOf(WPoints.Items[WPoints.ItemIndex]);
  IF i>-1
  THEN BEGIN
    WX.Caption := L_Points[i+1];
    WY.Caption := L_Points[i+2];
    WZ.Text := L_Points[i+3];
    WCarte.Caption := L_Points[i+4];
  END;
  WSupprimer.Enabled := True;WHaut.Enabled := True;
  WBas.Enabled := TRUE;WGauche.Enabled := TRUE;WDroit.Enabled := True;
end;

procedure TRandpla.WZChange(Sender: TObject);
VAR
  i : Integer;
begin
  i := L_Points.IndexOf(WPoints.Items[WPoints.ItemIndex]);
  IF i>-1
  THEN BEGIN
    L_Points[i+3] :=  WZ.Text;
    L_Points.SaveToFile(nom_rep+ini_projet+'\'+'Randr.'+
           Copy(Randpla.Label25.Caption,Length(Randpla.Label25.Caption)-1,2));
  END;
end;

procedure TRandpla.WsupprimerClick(Sender: TObject);
begin
  WPoints.Items.Delete(WPoints.ItemIndex);
  Renseigner;mettre_Points;
end;

procedure TRandpla.WnouveauClick(Sender: TObject);
begin
  OpenDialog1.InitialDir := nom_rep+ini_projet;
  OpenDialog1.Filter := GraphicFilter(TGraphic);
  IF OpenDialog1.Execute
  THEN BEGIN
    Randpla.Caption := OpenDialog1.FileName;
    MiseEnRoute;
  END;
end;

procedure TRandpla.WDessinerClick(Sender: TObject);
begin
  Renseigner;mettre_Points;
end;

procedure TRandpla.WHautClick(Sender: TObject);
VAR
  i : Integer;
begin
  IF WPoints.ItemIndex>-1
  THEN BEGIN
    i := L_Points.IndexOf(WPoints.Items[WPoints.ItemIndex]);
    IF i>-1
    THEN BEGIN
      L_Points[i+9] := IntToStr(StrToInt(L_Points[i+9])-10);
      Renseigner;mettre_Points;
    END;
  END;
end;

procedure TRandpla.WBasClick(Sender: TObject);
VAR
  i : Integer;
begin
  IF WPoints.ItemIndex>-1
  THEN BEGIN
    i := L_Points.IndexOf(WPoints.Items[WPoints.ItemIndex]);
    IF i>-1
    THEN BEGIN
      L_Points[i+9] := IntToStr(StrToInt(L_Points[i+9])+10);
      Renseigner;mettre_Points;
    END;
  END;
end;

procedure TRandpla.WGaucheClick(Sender: TObject);
VAR
  i : Integer;
begin
   IF WPoints.ItemIndex>-1
  THEN BEGIN
    i := L_Points.IndexOf(WPoints.Items[WPoints.ItemIndex]);
    IF i>-1
    THEN BEGIN
      L_Points[i+8] := IntToStr(StrToInt(L_Points[i+8])-10);
      Renseigner;mettre_Points;
    END;
  END;
end;

procedure TRandpla.WDroitClick(Sender: TObject);
VAR
  i : Integer;
begin
  IF WPoints.ItemIndex>-1
  THEN BEGIN
    i := L_Points.IndexOf(WPoints.Items[WPoints.ItemIndex]);
    IF i>-1
    THEN BEGIN
      L_Points[i+8] := IntToStr(StrToInt(L_Points[i+8])+10);
      Renseigner;mettre_Points;
    END;
  END;
end;

procedure TRandpla.Button1Click(Sender: TObject);
begin
  Randpla.Close;
end;

procedure TRandpla.WImprimerClick(Sender: TObject);
VaR
  Bmp : TBitmap;
  i_rect : Trect;
  Larg,Haut : Integer;
  Header,Bits : Pointer;
  HeaderSize,BitsSize,densit: DWord;
begin
  Bmp := TBitmap.Create;
  Bmp.Assign(Image1.Picture);    // Recopie de l'image1 dans un Bitmap
  IF Bmp.Width<Bmp.Height
  THEN Printer.Orientation := poPortrait
  ELSE Printer.Orientation := poLandscape;
  IF printDialog1.Execute
  THEN
    WITH Printer DO
    BEGIN
      Title := 'Carte de randonne';
      BeginDoc;
        densit := GetDeviceCaps(Printer.Handle,LOGPIXELSX);
                            // pixels par pouce de l'imprimante
        i_rect := Rect(0,0,Round(Bmp.Width*densit/densX),
                           Round(Bmp.Height*densit/densY));
                            // rapport entre densit du scanner
                            // et de l'imprimante afin de concerver
                            // 4 cm par kilomtre sur les cartes
        // *** debut API
        GetDibSizes(Bmp.Handle,HeaderSize,BitsSize);
        GetMem(Header,HeaderSize);  GetMem(Bits,BitsSize );
        GetDIB(Bmp.Handle,Bmp.Palette,Header^,Bits^);
        StretchDIBits(Canvas.Handle,
                      i_rect.Left,i_rect.Top,
                        i_rect.Right-i_rect.Left,i_rect.Bottom-i_rect.Top,
                      0,0,Bmp.Width,Bmp.Height,
                      Bits,TBitmapInfo(Header^),
                      DIB_RGB_COLORS,SRCCOPY);
         FreeMem(Header,HeaderSize);  FreeMem(Bits,BitsSize );
         // Fin *** Sur le conseil de Philippe Boucault le 6/4/01 et  cause
         //  des problmes alatoires ( des sorties de feuille blanche ) j'ai
         // fait un appel direct API Windows
      EndDoc;
    END;
  Bmp.FreeImage;
end;

end.
