unit Randorte;                         //247

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ComCtrls;

type
  TRandrte = class(TForm)
    LRoutes: TListBox;
    RInserer: TButton;
    Quitter: TButton;
    SaveDialog1: TSaveDialog;
    UpRoute: TUpDown;
    NumRoute: TMaskEdit;
    procedure FormActivate(Sender: TObject);
    procedure QuitterClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure LRoutesClick(Sender: TObject);
    procedure RInsererClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure UpRouteClick(Sender: TObject; Button: TUDBtnType);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Randrte: TRandrte;

implementation

{$R *.DFM}

USES
  RandoDec, Rando, Math;
  
VAR
  R_Routes    : TstringList;
  R_Points    : TstringList;
  R_nom       : String;

PROCEDURE Creer(NFichier: string);
VAR
  FRoute : TStringList;
  i      : Byte;
  cstr   : String;
BEGIN
  FRoute := TStringList.Create;FRoute.Clear;
  IF R_Points.Strings[7]='ED50'
  THEN FRoute.Add('Datum,European 1950,International,'+
                         '-251,-0.14192702,-87,-96,-120');
  IF R_Points.Strings[7]='WGS84'
  THEN FRoute.Add('Datum,WGS84,WGS84,0,0,0,0,0');
  STR(Randrte.UpRoute.Position:2,CStr);
  CStr := CStr +','+
        AnsiUpperCase(Randrte.LRoutes.Items.Strings[Randrte.LRoutes.ItemIndex]);
  FRoute.Add('RouteName,'+Cstr);
  FOR i:=0 TO (R_Points.Count DIV 10)-1 DO
  BEGIN
    Cstr := 'RoutePoint,UTM,'+R_Points.Strings[(i*10)+0]+' ,'+
            R_Points.Strings[(i*10)+5]+R_Points.Strings[(i*10)+6]+','+
            R_Points.Strings[(i*10)+1]+','+R_Points.Strings[(i*10)+2]+','+
            '01/01/2001,00:00:00,RANDONNEES';
    FRoute.Add(Cstr);
  END;
  FRoute.SaveToFile(NFichier);
  FRoute.Free;
END;

FUNCTION Distance(ox1,oy1,ox2,oy2:String):Integer;
VAR
  r_o : Real;
BEGIN
  r_o := Power((Power(StrToInt(ox1)-StrToInt(ox2),2)+
                Power(StrToInt(oy2)-StrToInt(oy1),2)),0.5);
  Distance := Round(r_o);
END;

FUNCTION Oriente(ox1,oy1,ox2,oy2:String):Integer;
VAR
  r_o : Real;
BEGIN
  IF StrToInt(ox1)-StrToInt(ox2)=0
  THEN BEGIN
    IF (StrToInt(oy2)-StrToInt(oy1))>= 0
    THEN r_o:= 90.0
    ELSE r_o := -90.0;
  END
  ELSE BEGIN
    r_o := RadToDeg(ArcTan2(StrToInt(oy2)-StrToInt(oy1),
                            StrToInt(ox2)-StrToInt(ox1)));
  END;
  R_o := 90.0-r_o;
  WHILE r_o<=0.0 DO
    r_o := r_o+360;
  Oriente := Round(r_o/5)*5;
END;

PROCEDURE inserer;
VAR
  i : Integer;
  j : Integer;
BEGIN
  Rand.liste_eta.Enabled := FALSE;
  FOR j:=0 TO (R_Points.Count DIV 10)-1 DO
    WITH Rand DO
    BEGIN
      IF liste_eta.Row<50
        THEN FOR i:=50 DOWNTO liste_eta.Row+1 DO
            liste_eta.Rows[i] := liste_eta.Rows[i-1];
      Liste_eta.Col := 0;
      Liste_eta.Cells[Liste_eta.Col,Liste_eta.Row] := R_Points.Strings[j*10];
      Liste_eta.col := 1;
      IF j<((R_Points.Count DIV 10)-1)
      THEN Liste_eta.Cells[Liste_eta.Col,Liste_eta.Row] := 'M '
      ELSE Liste_eta.Cells[Liste_eta.Col,Liste_eta.Row] := '';
      Liste_eta.col := 2;
      IF j<((R_Points.Count DIV 10)-1)
      THEN Liste_eta.Cells[Liste_eta.Col,Liste_eta.Row] :=
                          IntToStr(Oriente(R_Points.Strings[(j*10)+1],
                                           R_Points.Strings[(j*10)+2],
                                           R_Points.Strings[(j*10)+11],
                                           R_Points.Strings[(j*10)+12]))
      ELSE Liste_eta.Cells[Liste_eta.Col,Liste_eta.Row] := '';
      Liste_eta.Col := 3;
      Liste_eta.Cells[Liste_eta.Col,Liste_eta.Row] :=
                      R_Points.Strings[(j*10)+5]+
                      R_Points.Strings[(j*10)+6]+' '+
                      R_Points.Strings[(j*10)+1]+' '+
                      R_Points.Strings[(j*10)+2];
      Liste_eta.Col := 4;
      Liste_eta.Cells[Liste_eta.Col,Liste_eta.Row] :=
                      R_Points.Strings[(j*10)+3];
      Liste_eta.Col := 5;
      IF j<((R_Points.Count DIV 10)-1)
      THEN Liste_eta.Cells[Liste_eta.Col,Liste_eta.Row] :=
                          IntToStr(Distance(R_Points.Strings[(j*10)+1],
                                            R_Points.Strings[(j*10)+2],
                                            R_Points.Strings[(j*10)+11],
                                            R_Points.Strings[(j*10)+12]))
      ELSE Liste_eta.Cells[Liste_eta.Col,Liste_eta.Row] := '';
      Liste_eta.Row := Liste_eta.Row +1;
    END;
  Rand.liste_eta.Enabled := TRUE;
END;

procedure TRandrte.FormActivate(Sender: TObject);
VAR
  i : Integer;
begin
  R_Routes := TstringList.Create;
  LRoutes.Items.Clear;
  IF Randrte.Caption[1]='C'
  THEN BEGIN
    RInserer.Caption := '&Exporter';
    IF Rand.liste_iti.Row<30
    THEN UpRoute.Position := (Rand.liste_iti.Row+1)
    ELSE UpRoute.Position := 30;
    NumRoute.Text := IntToStr(UpRoute.Position);
    Randrte.Caption := 'Cre un fichier GPS de la route n '+
                        IntToStr(UpRoute.Position);
    NumRoute.Visible := TRUE;UpRoute.Visible := TRUE;
    LRoutes.HelpContext := 7;NumRoute.HelpContext := 7;Quitter.HelpContext :=7;
    Randrte.HelpContext := 7;RInserer.HelpContext := 7;UpRoute.HelpContext :=7;
  END
  ELSE BEGIN
    RInserer.Caption := '&Insrer';
    NumRoute.Visible := FALSE;UpRoute.Visible := FALSE;
  END;
  TRY
    R_Routes.LoadFromFile(nom_rep+'\'+ini_projet+'\'+'Randr.rnd');
  EXCEPT
    ON EFOpenError DO
    BEGIN
      R_Routes.Clear;RandRte.Hide;
    END;
  END;
  IF R_Routes.Count>0
  THEN BEGIN
    FOR i := 0 TO (R_Routes.Count DIV 2)-1 DO
      LRoutes.Items.Add(R_Routes[i*2]);
  END;
end;

procedure TRandrte.QuitterClick(Sender: TObject);
begin
  RandRte.Hide;
end;

procedure TRandrte.FormDeactivate(Sender: TObject);
begin
  R_Routes.Free;
end;

procedure TRandrte.LRoutesClick(Sender: TObject);
begin
  RInserer.Enabled := TRUE;
end;

procedure TRandrte.RInsererClick(Sender: TObject);
begin
  R_Points := TStringList.Create;
  R_nom := R_Routes[1+R_Routes.IndexOf(LRoutes.Items.Strings[LRoutes.itemIndex])];
  R_nom := nom_rep+'\'+ini_projet+'\'+'Randr.'+R_nom;
  TRY
    R_Points.LoadFromFile(R_nom);
  EXCEPT
    ON EFOpenError DO
    BEGIN
      R_Points.Clear;RandRte.Hide;
    END;
  END;
  IF R_Points.Count>0
  THEN BEGIN
    IF Randrte.Caption[1]='I'
    THEN inserer
    ELSE BEGIN
      SaveDialog1.InitialDir := nom_rep+ini_projet+'\';
      SaveDialog1.FileName := Randrte.LRoutes.Items.Strings
                                [Randrte.LRoutes.ItemIndex]+'.TXT';
      SaveDialog1.Title := 'Cre un fichier au format Waypoint +';
      IF SaveDialog1.Execute
      THEN Creer(SaveDialog1.Files[0]);
    END;
    R_Points.Clear;RandRte.Hide;
  END
  ELSE BEGIN
    R_Points.Clear;RandRte.Hide;
  END;
end;

procedure TRandrte.FormShow(Sender: TObject);
begin
  RInserer.Enabled := FALSE;
end;

procedure TRandrte.UpRouteClick(Sender: TObject; Button: TUDBtnType);
begin
  NumRoute.Text := IntToStr(UpRoute.Position);
  Randrte.Caption := 'Cre un fichier GPS de la route n '+
                        IntToStr(UpRoute.Position);
end;

end.
